#include <stdio.h>
#include <stdlib.h>
#include "cmnCmdOptions.h"
//#include <conio.h>
//#include <dstuff.h>

int     txtToIhexMode;
char *  inputFileName;

char* optsMode[1] = {"-2"};
char* optsHelp[1] = {"--help"};
char* optsFile[2] = {"-i", "-I"};
char* optsVers[1] = {"-v"};
char* optsC[1]    = {"-c"};

int setMode2(char * unused);
int setModeC(char * unused);
int setInputFileName(char * filename);
int printVersion(char * unused);
int printHelp(char * unused); 


int main(int argc, char** argv) {
  FILE* input;
  unsigned char line[17];
  unsigned long pos;
  char count;
  char got;

  txtToIhexMode = 0;
  inputFileName = NULL;

  cmdLineOptionInit();
  addCmdLineOption(optsMode, 1, setMode2);
  addCmdLineOption(optsHelp, 1, printHelp);
  addCmdLineOption(optsFile, 2, setInputFileName);
  addCmdLineOption(optsVers, 1, printVersion);
  addCmdLineOption(optsC,    1, setModeC);
  
  
  parseOptions(argc, argv);

  if (inputFileName == NULL) {
     return 0;
  }
  
  if ((input = fopen(inputFileName, "rb")) == NULL)       
  {
    printf("Unable to open %s for input.\n", argv[1]);
    return -1;
  }

// headers
  if (txtToIhexMode == 2) {
   printf("char data[] = { \\\n");  
  }


   pos = 0;

   while ((got = fread(&line[0], 1, 16, input)) > 0 )
     {

      //---- address -----
      if (txtToIhexMode == 0) {
         printf("%04lX:", pos);
      } else if (txtToIhexMode == 1) {
         printf("%04lX", pos);
      } // no address for C dump


     // data conversions...
      for (count = 0; count < got; count++) {
      
       if ((count == 8) & (txtToIhexMode == 0))
         printf(" -");

       if ((txtToIhexMode == 0) | (txtToIhexMode ==1)) {
       
           printf(" %02X", line[count]);
           
       }else if (txtToIhexMode == 2) {
       
           printf(" 0x%02X", line[count]);
           if (count != (got-1)) {
              printf(",");
           } else {
              printf(" \\");
           }
       }
      }

      // character translations for old school dump format  
      if (txtToIhexMode == 0) {
        printf("  ");

        for (count = 0; count < got; count++)
         {
           if ((line[count] >= 32) && (line[count] < 127))
            printf("%c", line[count]);
           else
            printf(".");
         }        

               
      }
      
      pos += 16;
      printf("\n");
      
     }
    // footers
     
    if (txtToIhexMode == 2) printf(" };");
     
  return 0;
 }


 int setMode2(char * unused) {
    txtToIhexMode = 1;
    return 0;
 }

 int setModeC(char * unused) {
    txtToIhexMode = 2;
    return 0;
 }

 int setInputFileName(char * filename) {
   inputFileName = filename;
   return 1;
 }

 int printVersion(char * unused) {
   printf("Version 3\n");
   return 0;
 }

 int printHelp(char * unused) {
   
  printf(" Truedump, By Dan Williams, Written before recorded time.\n\n");
  printf(" This program dumps an un-interperted version of the specified\n");
  printf("   file in a text-hex format. \n\n");
  printf(" Options: \n");
  printf("   -2          Use mode 2. For use with txt2ihex\n");
  printf("   --help      Print help info (hint, your looking at it.)\n");
  printf("   -i filename Set input filename\n");
  printf("   -v          Report version only\n");
  printf("   -c          Output C code.\n");
  printf("\n");
  printf(" use:  truedump [-2] [-c] [--help] [-v] -i filename  \n");
   
  return 0;
 }
